//
//  AppDelegate.m
//  SubnetMapper
//
//  Created by Thomas Thiel on 25.06.08.
//  Copyright 2008 Thomas Thiel. All rights reserved.
//
// THIS CODE REPRESENTS FREE SOFTWARE AND IS RELEASED 
// UNDER THE GPL LICENSE VERSION 2. PLEASE RESPECT
// THE TERMS OF THIS LICENSE, WHICH CAN BE REVIEWED AT:
// http://www.gnu.org/licenses/gpl-2.0.html

#import "AppDelegate.h"


@implementation AppDelegate

- (id) init {
	self = [super init];
	if (self) {

		applicationHasStarted=FALSE;
	
	}
	return self;
}


- (BOOL)applicationShouldOpenUntitledFile:(NSApplication *)sender
{
	// On startup, when asked to open an untitled file, open the last opened
	// file instead. If no document is open, and the dock icon is clicked,
	// open the last doc too. Will NOT be invoked, if new doc is manually 
	// openend, because NSApp will not evaluate ths command itself, it will
	// stay in the document Framework then.
	
	if (!((applicationHasStarted)&([[sender orderedDocuments]count]>0)))
	{
		// Get the recent documents
		NSDocumentController *controller =
		[NSDocumentController sharedDocumentController];
		NSArray *documents = [controller recentDocumentURLs];
		
		// set to true to mark a successful app startup - NSApplication can not tell us this state.
		applicationHasStarted=TRUE;
		
		// If there is a recent document, try to open it.
		if ([documents count] > 0)
		{
			NSError *error = nil;
			[controller
			 openDocumentWithContentsOfURL:[documents objectAtIndex:0]
			 display:YES error:&error];
			
			// If there was no error, then prevent untitled from appearing.
			if (error == nil)
			{
				return NO;
			}
		}
	}
	
	return YES;
}

@end
