//
//  MapView.h
//  SubnetMapper
//
//  Created by Thomas Thiel on 25.06.08.
//  Copyright 2008 Thomas Thiel. All rights reserved.
//
// THIS CODE REPRESENTS FREE SOFTWARE AND IS RELEASED 
// UNDER THE GPL LICENSE VERSIN 2. PLEASE RESPECT
// THE TERMS OF THIS LICENSE, WHICH CAN BE REVIEWED AT:
// http://www.gnu.org/licenses/gpl-2.0.html

#import <Cocoa/Cocoa.h>

@interface MapView : NSView {

	IBOutlet NSDocument* _document;
	unsigned int cachedNumberOfRows;
	unsigned int cachedNumberOfSubnets;
	NSMutableArray* cachedRectangles;
	NSMutableArray* cachedLines;
	NSMutableArray* cachedNets;
	
	NSImage *notesIcon;
	NSImage *pinIcon;
	
	BOOL showHosts;
	NSArray* findHostList;
	
	Subnet* _selected_subnet;
	
	float page_x_offset;
	float page_y_offset;
	float ip_multiplier;
	float block_y_offset;
	float row_height;
	
	IBOutlet NSTextField* _drawer_subnet_label_ip;
	IBOutlet NSTextField* _drawer_subnet_label_netmask;
	IBOutlet NSTextField* _drawer_subnet_label_wildcard;
	IBOutlet NSTextField* _drawer_subnet_label_usablesize;
	IBOutlet NSTextField* _drawer_subnet_label_firstip;
	IBOutlet NSTextField* _drawer_subnet_label_lastip;
	IBOutlet NSTextField* _drawer_subnet_label_broadcast;
	IBOutlet NSTextField* _drawer_subnet_label_identifier;
	IBOutlet NSTextField* _drawer_subnet_label_description;

	IBOutlet NSTableView* _subnet_table;
}

- (void) setCachedNumberOfSubnets:(unsigned int)number;
- (unsigned int) cachedSubnets;

- (void) showHost:(NSString*)host;
- (IBAction) clearMarkings:(id)sender;

- (void) refreshCache;
- (void) refreshUserDefaults;

- (void) displayDrawer:(Subnet*)selSubnet;

- (NSArray*) getFindHostList;
- (void) setFindHostList:(NSArray*)list;
- (Subnet*) getSelectedSubnet;
- (void) setSelectedSubnet:(Subnet*)subnet;

@end
