//
//  MyDocument.h
//  SubnetMapper
//
//  Created by Thomas Thiel on 16.06.08.
//  Copyright Thomas Thiel 2008 . All rights reserved.
//
// THIS CODE REPRESENTS FREE SOFTWARE AND IS RELEASED 
// UNDER THE GPL LICENSE VERSIN 2. PLEASE RESPECT
// THE TERMS OF THIS LICENSE, WHICH CAN BE REVIEWED AT:
// http://www.gnu.org/licenses/gpl-2.0.html


#import <Cocoa/Cocoa.h>
#import "Subnet.h"

@interface MyDocument : NSDocument
{
	NSMutableArray* _subnets;
	Subnet* _edited_subnet;
	IBOutlet NSView* _mapview;
	
	IBOutlet NSWindow* _add_subnet_panel;	
	IBOutlet NSWindow* _edit_subnet_panel;	

	IBOutlet NSTextField* _add_subnet_cidr;
	IBOutlet NSTextField* _add_subnet_nmoctet0;
	IBOutlet NSTextField* _add_subnet_nmoctet1;
	IBOutlet NSTextField* _add_subnet_nmoctet2;
	IBOutlet NSTextField* _add_subnet_nmoctet3;
	IBOutlet NSTextField* _add_subnet_identifier;
	IBOutlet NSTextField* _add_subnet_description;
	IBOutlet NSButton* _add_subnet_cidrdesc;
	IBOutlet NSButton* _add_subnet_cancel;
	IBOutlet NSButton* _add_subnet_add;
	IBOutlet NSTextField* _add_subnet_ipoct0;
	IBOutlet NSTextField* _add_subnet_ipoct1;
	IBOutlet NSTextField* _add_subnet_ipoct2;
	IBOutlet NSTextField* _add_subnet_ipoct3;
	IBOutlet NSTextView* _add_subnet_notes;
	
	IBOutlet NSTextField* _edit_subnet_cidr;
	IBOutlet NSStepper* _edit_subnet_cidr_stepper;
	IBOutlet NSTextField* _edit_subnet_nmoctet0;
	IBOutlet NSTextField* _edit_subnet_nmoctet1;
	IBOutlet NSTextField* _edit_subnet_nmoctet2;
	IBOutlet NSTextField* _edit_subnet_nmoctet3;
	IBOutlet NSTextField* _edit_subnet_identifier;
	IBOutlet NSTextField* _edit_subnet_description;
	IBOutlet NSButton* _edit_subnet_cidrdesc;
	IBOutlet NSButton* _edit_subnet_cancel;
	IBOutlet NSButton* _edit_subnet_add;
	IBOutlet NSTextField* _edit_subnet_ipoct0;
	IBOutlet NSTextField* _edit_subnet_ipoct1;
	IBOutlet NSTextField* _edit_subnet_ipoct2;
	IBOutlet NSTextField* _edit_subnet_ipoct3;
	IBOutlet NSTextView* _edit_subnet_notes;

	IBOutlet NSTextField* _edit_subnet_label_ip;
	IBOutlet NSTextField* _edit_subnet_label_netmask;
	IBOutlet NSTextField* _edit_subnet_label_wildcard;
	IBOutlet NSTextField* _edit_subnet_label_usablesize;
	IBOutlet NSTextField* _edit_subnet_label_firstip;
	IBOutlet NSTextField* _edit_subnet_label_lastip;
	IBOutlet NSTextField* _edit_subnet_label_broadcast;
	IBOutlet NSTextField* _edit_subnet_label_identifier;
	IBOutlet NSTextField* _edit_subnet_label_description;
	
	NSImage *notesIcon;

};

- (void) addSubnet2Doc:(Subnet*)subnet;

- (void) setSubnets:(NSMutableArray*)subnets;
- (NSMutableArray*) subnets;
- (void)didEndSheet:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;
- (void)changeColor:(id)sender;

- (void) displayError:(NSString*)error info:(NSString*)info;

- (IBAction) checkAddSubnetSheetInput:(id)sender;
- (IBAction) checkEditSubnetSheetInput:(id)sender;
- (IBAction) closeAddSubnetSheet:(id)sender;
- (IBAction) closeEditSubnetSheet:(id)sender;
- (IBAction) addSubnet:(id)sender;
- (IBAction) removeSubnet:(id)sender;
- (IBAction) showColorPanel:(id)sender;
- (IBAction) editAllSubnets:(id)sender;
- (IBAction) editSubnet:(id)sender;
- (IBAction) searchHost:(id)sender;

- (void) editSingleSubnet:(Subnet*)subnet;

- (unsigned int) getNumberOfSubnets;
- (unsigned int) getNumberOfNets;

- (Subnet*) getSubnetAtIndex:(unsigned int)index;

// Data Source Selectors for NSTableView
- (id)tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex;
- (void)tableView:(NSTableView *)aTableView setObjectValue:(id)anObject forTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex;
- (int)numberOfRowsInTableView:(NSTableView *)aTableView;

// Delegate Selectors for NSTableView
- (BOOL)tableView:(NSTableView *)aTableView shouldSelectRow:(int)rowIndex;
@end

