//
//  SubnetRect.m
//  SubnetMapper
//
//  Created by Thomas Thiel on 26.06.08.
//  Copyright 2008 Thomas Thiel. All rights reserved.
//
// THIS CODE REPRESENTS FREE SOFTWARE AND IS RELEASED 
// UNDER THE GPL LICENSE VERSIN 2. PLEASE RESPECT
// THE TERMS OF THIS LICENSE, WHICH CAN BE REVIEWED AT:
// http://www.gnu.org/licenses/gpl-2.0.html

#import "Subnet.h"
#import "SubnetRect.h"


@implementation SubnetRect

- (id) init {

	self = [self initX:[NSNumber numberWithFloat:0.0] Y:[NSNumber numberWithFloat:0.0] width:[NSNumber numberWithFloat:0.0] height:[NSNumber numberWithFloat:0.0] subnet:nil];

	return self;
};

- (id) initX:(NSNumber*)x Y:(NSNumber*)y width:(NSNumber*)width height:(NSNumber*)height subnet:(Subnet*)subnet {
	self = [super init];
	if (self) {
		[self setX:x];
		[self setY:y];
		[self setWidth:width];
		[self setHeight:height];
		[self setSubnet:subnet];
		[self setSelected:NO];
	}
	return self;	
};

+ (SubnetRect*)SubnetRect {
	return [[[SubnetRect alloc] init] autorelease];
};

+ (SubnetRect*)SubnetRectX:(NSNumber*)x Y:(NSNumber*)y width:(NSNumber*)width height:(NSNumber*)height subnet:(Subnet*)subnet {
	return [[[SubnetRect alloc] initX:x Y:y width:width height:height subnet:subnet] autorelease];
};

- (void) dump2Log {
	NSLog(@"----------------------------------------");
	NSLog(@"SubnetRect:     %p",self);
	NSLog(@"Origin:         %f/%f",[[self getX] floatValue],[[self getY] floatValue]);
	NSLog(@"Size:           %f/%f",[[self getWidth] floatValue],[[self getHeight] floatValue]);
	NSLog(@"----------------------------------------");
};

- (NSNumber*) getX {
	return _x;
};

- (NSNumber*) getY {
	return _y;
};

- (NSNumber*) getWidth {
	return _width;
};

- (NSNumber*) getHeight {
	return _height;
};

- (void) setX:(NSNumber*)x {
	if(_x!=x) {
		
		[_x release];
		_x=[[NSNumber numberWithFloat:[x floatValue]] retain];
		
	};
};

- (void) setY:(NSNumber*)y {
	if(_y!=y) {
		
		[_y release];
		_y=[[NSNumber numberWithFloat:[y floatValue]] retain];
		
	};
};

- (void) setWidth:(NSNumber*)width {
	if(_width!=width) {
		
		[_width release];
		_width=[[NSNumber numberWithFloat:[width floatValue]] retain];
		
	};
};

- (void) setHeight:(NSNumber*)height {
	if(_height!=height) {
		
		[_height release];
		_height=[[NSNumber numberWithFloat:[height floatValue]] retain];
		
	};
};

- (Subnet*) getSubnet {
	return _subnet;
};

- (void) setSubnet:(Subnet*)subnet {

	if(_subnet!=subnet) {
		
		[_subnet release];
		_subnet=[subnet retain];
		
	};
};

- (BOOL) isSelected {
	return [[self getSubnet] isSelected];
};

- (void) setSelected:(BOOL)state {
	[[self getSubnet] setSelected:state];
};

- (void) dealloc {
	
	[self setX:nil];
	[self setY:nil];
	[self setWidth:nil];
	[self setHeight:nil];
	
	[super dealloc];
	
};

@end
